/*
    Introduction to OOP with Java (5th Ed), McGraw-Hill

    Wu/Otani

    Chapter 9 Sample Program: Checks whether the input
            string conforms to the phone number
            pattern xxx-xxx-xxxx.  This version
            uses the Matcher and Pattern classes.

    File: Ch9MatchPhoneNumberPM.java
*/

import java.util.*;
import java.util.regex.*;

class Ch9MatchPhoneNumberPM {

    private static final String STOP = "0";
    private static final String VALID = "Valid phone number";
    private static final String INVALID = "Not a valid phone number";

    private static final String VALID_PHONE_PATTERN
                   = "[0-9][0-9][0-9]-[0-9][0-9][0-9]-[0-9][0-9][0-9][0-9]";

                // = "[0-9]{3}-[0-9]{3}-[0-9]{4}";

                // = "\\d{3}-\\d{3}-\\d{4}";

    public static void main (String[] args) {

        Scanner scanner = new Scanner(System.in);
        
        String phoneStr, reply;

        Pattern phonePattern = Pattern.compile(VALID_PHONE_PATTERN);
        Matcher phoneMatcher;

        while (true) {

            System.out.print("Phone#: ");
            phoneStr = scanner.next();

            if (phoneStr.equals(STOP)) break;

            phoneMatcher = phonePattern.matcher(phoneStr);

            if (phoneMatcher.matches()) {
                reply = VALID;

            } else {
                reply = INVALID;
            }

            System.out.println(phoneStr + ": " + reply + "\n");
        }
    }
}